/*
 * RS485ISO.cpp
 * 
 * Copyright 2013 OLIMEX LTD/Stefan Mavrodiev <support@olimex.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */
 

#include "RS485ISO.h"
#include "../Wire/Wire.h"



/*
 * Class variables
 */
 uint8_t RS485ISO::address = 0x22;
 uint8_t RS485ISO::clc_status = 0x00;
 uint8_t RS485ISO::CHANNEL_IN = 0x02;
 uint8_t RS485ISO::CHANNEL_OUT = 0x01;
 

/*
 * Constructors
 */
RS485ISO::RS485ISO(){
}

RS485ISO::RS485ISO(uint8_t addr){
    address = addr;
}

void RS485ISO::setAddress(uint8_t newAddress){
    Wire.begin();
    Wire.beginTransmission(address);
    Wire.write(SET_ADDRESS);
    Wire.write(newAddress);
    Wire.endTransmission();
}
uint8_t RS485ISO::getID(void){
    unsigned char data;  
    Wire.begin();
    Wire.beginTransmission(address);
    Wire.write(GET_ID);
    Wire.endTransmission();
    Wire.requestFrom((int)address, 1);
    data = Wire.read();
    
    return data;    
}

void RS485ISO::openChannel(uint8_t channel){
    clc_status |= channel;
    Wire.begin();
    Wire.beginTransmission(address);
    Wire.write(SET_CLC);
    Wire.write(clc_status);
    Wire.endTransmission();
}
void RS485ISO::closeChannel(uint8_t channel){
    clc_status &= ~(channel);
    Wire.begin();
    Wire.beginTransmission(address);
    Wire.write(SET_CLC);
    Wire.write(clc_status);
    Wire.endTransmission();
}
