/*
 * RS485ISO.h
 * 
 * Copyright 2013 OLIMEX LTD/Stefan Mavrodiev <support@olimex.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef RS485ISO_H
#define RS485ISO_H

#include <inttypes.h>


#define SET_ADDRESS 	0xF0
#define GET_ID		0x20
#define SET_CLC		0x30

class RS485ISO
{
    private:
        static uint8_t address;
	static uint8_t clc_status;
    public:
        RS485ISO();
        RS485ISO(uint8_t);
	void setAddress(uint8_t newAddress);
	void openChannel(uint8_t channel);
	void closeChannel(uint8_t channel);
	uint8_t getID(void);	
	
	static uint8_t CHANNEL_IN;
	static uint8_t CHANNEL_OUT;

};
#endif
